VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "LoadBal Tester"
   ClientHeight    =   3735
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6735
   LinkTopic       =   "Form1"
   ScaleHeight     =   3735
   ScaleWidth      =   6735
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkTimer 
      Caption         =   "AutoTimer"
      Height          =   255
      Left            =   4800
      TabIndex        =   9
      ToolTipText     =   "Automatically re-read the counter once every 5 seconds"
      Top             =   960
      Width           =   1575
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   5000
      Left            =   6240
      Top             =   3240
   End
   Begin VB.TextBox txtValue 
      BackColor       =   &H8000000F&
      Enabled         =   0   'False
      Height          =   375
      Left            =   1680
      TabIndex        =   8
      ToolTipText     =   "Resulting value, or error code"
      Top             =   2400
      Width           =   4215
   End
   Begin VB.TextBox txtCounter 
      Height          =   375
      Left            =   1680
      TabIndex        =   5
      Text            =   "Current Connections"
      ToolTipText     =   "Perfomon counter name, must be a simple numeric counter type"
      Top             =   1560
      Width           =   2415
   End
   Begin VB.TextBox txtObject 
      Height          =   375
      Left            =   1680
      TabIndex        =   3
      Text            =   "HTTP Service"
      ToolTipText     =   "Permon counter object"
      Top             =   960
      Width           =   2415
   End
   Begin VB.TextBox txtServer 
      Height          =   375
      Left            =   1680
      TabIndex        =   1
      Text            =   "."
      ToolTipText     =   "Target server name, such as MYSERVER (. means local server)"
      Top             =   360
      Width           =   2415
   End
   Begin VB.CommandButton cmdRead 
      Caption         =   "ReadCounter"
      Height          =   375
      Left            =   4800
      TabIndex        =   0
      ToolTipText     =   "Execute a single read of the perfmon counter"
      Top             =   360
      Width           =   1575
   End
   Begin VB.Label lblBlocked 
      Alignment       =   2  'Center
      Caption         =   "Blocked in COM Call"
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   15.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000011&
      Height          =   375
      Left            =   1440
      TabIndex        =   10
      Top             =   3000
      Visible         =   0   'False
      Width           =   3735
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Current Value"
      Height          =   255
      Left            =   285
      TabIndex        =   7
      Top             =   2475
      Width           =   1200
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Counter Name"
      Height          =   255
      Left            =   285
      TabIndex        =   6
      Top             =   1635
      Width           =   1200
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Object Name"
      Height          =   255
      Left            =   285
      TabIndex        =   4
      Top             =   1035
      Width           =   1200
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Server"
      Height          =   255
      Left            =   285
      TabIndex        =   2
      Top             =   435
      Width           =   1200
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim objLB As Object

Private Sub Form_Load()
On Error GoTo Handler
Set objLB = CreateObject("mcs.loadbalancer.1")
Exit Sub

Handler:
MsgBox "Failed to load MCS.LoadBalancer.1"
End
End Sub

Private Sub chkTimer_Click()
If chkTimer.Value = 1 Then
    Timer1.Enabled = True
Else
    Timer1.Enabled = False
End If

End Sub


Private Sub cmdRead_Click()
Dim szServer As String
Dim szObject As String
Dim szCounter As String
Dim dwValue As Long

On Error GoTo Handler

lblBlocked.Visible = True
txtValue.Text = ""
DoEvents

szServer = txtServer.Text
szObject = txtObject.Text
szCounter = txtCounter.Text
dwValue = objLB.ReadCounter(szServer, szObject, szCounter)
txtValue.Text = GetErrorString(dwValue)
lblBlocked.Visible = False
Exit Sub

Handler:
txtValue.Text = Err.Description
lblBlocked.Visible = False

End Sub


Private Sub Form_Unload(Cancel As Integer)
Set objLB = Nothing
End Sub

Private Sub Timer1_Timer()
Call cmdRead_Click
End Sub

Private Function GetErrorString(dwValue As Long) As String

Select Case dwValue
    Case -1
        GetErrorString = "ERROR_FAILED_KEY_OPEN"
    Case -2
        GetErrorString = "ERROR_FAILED_KEY_READ"
    Case -3
        GetErrorString = "ERROR_FAILED_MEMORY_ALLOC"
    Case -4
        GetErrorString = "ERROR_INVALID_COUNTER"
    Case -5
        GetErrorString = "ERROR_SHORT_BUFFER"
    Case -6
        GetErrorString = "ERROR_INVALID_PERF_BLOCK"
    Case -7
        GetErrorString = "ERROR_UNSUPPORTED_COUNTER_TYPE"
    Case -8
        GetErrorString = "ERROR_COUNTER_NOT_FOUND"
    Case Else
        GetErrorString = CStr(dwValue)
    
End Select


End Function
